###############################################################################################
##																							 ##
##   R Code for performing simulations for scenarios 3 and 4 in the paper					 ##
## "How much are we missing in SNP-by-SNP analyses of GWAS?" M Shi, CR Weinberg Epidemiology ##
##	2011																					     ##
###############################################################################################
run.sim <- function(snp.num,hap.num, hap.goal,freq.hap1,hap.type,risk.hap.dis,risk.hap.dis.e,
                      e.fr,  freq.hap2, risk.hap.dis2,risk.hap.dis.e2, e.fr2,pop1.fr, n.fam,iter=1)
{
 freq.hap <- freq.hap1
 for (i in 1:iter) {
 total.n <- 0
 n.loci <- 4
snp.ct.e1 <-rep(0,n.loci*2)
snp.ct.e0 <-rep(0,n.loci*2)
snp.ct0.e1 <-rep(0,n.loci*2)
snp.ct0.e0 <-rep(0,n.loci*2)
set.ct.e0 <-c(0,0)
set.ct.e1 <-c(0,0)
set.ct0.e0 <-c(0,0)
set.ct0.e1 <-c(0,0)
env.ct <- 0
 count.fam=1
   pedigree<-NULL
   all.fam.delta<-NULL
   pop.vec<-NULL
      env0.vec <- NULL
      while (count.fam<=n.fam)
   {
     # This while loop is used to create disease status only affected families
     # will be retained.
      if (count.fam ==1) .append <- FALSE else .append <- TRUE
     aff <-0
       while ( ! aff)
       {
             total.n <- total.n+1
         pop <-sample(c(1,2),1,prob=c(pop1.fr,1-pop1.fr),replace=T)
          if (pop==1) {e.fr.sel<-e.fr; freq.hap.sel<-freq.hap} else {
                       e.fr.sel<-e.fr2;freq.hap.sel<-freq.hap2}

         env <-sample(c(0,1),1,prob=c(1-e.fr.sel,e.fr.sel),replace=T)
         env0 <-sample(c(0,1),1,prob=c(1-e.fr.sel,e.fr.sel),replace=T)
         env.ct <- env.ct+env
         if (env ==1 & pop==1) risk.dis<-risk.hap.dis.e
         if (env ==1 & pop==2) risk.dis<-risk.hap.dis.e2
         if (env ==0 & pop==1) risk.dis<-risk.hap.dis
         if (env ==0 & pop==2) risk.dis<-risk.hap.dis2
         risk.e <- risk.hap.dis.e[1]/risk.hap.dis[1]
         risk.g <- risk.hap.dis[2]/risk.hap.dis[1]
         risk.i <- risk.hap.dis.e[2]/risk.hap.dis[2]/risk.e
 geno.f <- NULL
 geno.m <- NULL
 geno.kid <- NULL
 geno.kid2 <- NULL
for (k in 1:(2*n.loci)){
    hap.f1 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
    hap.f2 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
    geno.f <- c(geno.f, hap.type[2:(snp.num+1),hap.f1]+hap.type[2:(snp.num+1),hap.f2]-2)

    hap.m1 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
    hap.m2 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
    geno.m <- c(geno.m, hap.type[2:(snp.num+1),hap.m1]+ hap.type[2:(snp.num+1),hap.m2] -2)

    hap.fro.f <-sample(c(hap.f1,hap.f2),1,prob=c(0.5,0.5),replace=T)
    hap.fro.m <-sample(c(hap.m1,hap.m2),1,prob=c(0.5,0.5),replace=T)
    geno.kid <- c(geno.kid, hap.type[2:(snp.num+1),hap.fro.f]+hap.type[2:(snp.num+1),hap.fro.m] -2)

    hap.fro.f <-sample(c(hap.f1,hap.f2),1,prob=c(0.5,0.5),replace=T)
    hap.fro.m <-sample(c(hap.m1,hap.m2),1,prob=c(0.5,0.5),replace=T)
    geno.kid2 <- c(geno.kid2, hap.type[2:(snp.num+1),hap.fro.f]+hap.type[2:(snp.num+1),hap.fro.m] -2)

if (geno.kid[k]>0 & env) snp.ct.e1[k]<-snp.ct.e1[k]+1
if (geno.kid[k]>0 & (env==0)) snp.ct.e0[k]<-snp.ct.e0[k]+1
if (geno.kid[k]==0 & env) snp.ct0.e1[k]<-snp.ct0.e1[k]+1
if (geno.kid[k]==0 & (env==0)) snp.ct0.e0[k]<-snp.ct0.e0[k]+1
}
     
     if (sum(geno.kid[1:n.loci]>0)==n.loci) .set1 <- TRUE else .set1 <- FALSE
     if (sum(geno.kid[(n.loci+1):(2*n.loci)]>0)==n.loci) .set2 <- TRUE else .set2 <- FALSE
     risk.kid <- min( 1,risk.e^env*risk.g^.set1*risk.i^(.set1&env)*risk.g^.set2*risk.hap.dis[1])
   aff<-sample(c(1,0),1,prob=c(risk.kid,1-risk.kid),replace=T)
     
     if (.set1) {
    if (env) set.ct.e1[1] <-set.ct.e1[1] +1 else set.ct.e0[1] <-set.ct.e0[1] +1} 
     if (.set2) {
    if (env) set.ct.e1[2] <-set.ct.e1[2] +1 else set.ct.e0[2] <-set.ct.e0[2] +1
      } 
     
 if (!.set1 & env) set.ct0.e1[1] <- set.ct0.e1[1]+1 
 if (!.set1 & (env==0)) set.ct0.e0[1] <- set.ct0.e0[1]+1 
 if (!.set2 & env) set.ct0.e1[2] <- set.ct0.e1[2]+1 
 if (!.set2 & (env==0)) set.ct0.e0[2] <- set.ct0.e0[2]+1 
     if (sum(geno.kid2[1:n.loci]>0)==n.loci) .set1 <- TRUE else .set1 <- FALSE
     if (sum(geno.kid2[(n.loci+1):(2*n.loci)]>0)==n.loci) .set2 <- TRUE else .set2 <- FALSE
     risk.kid <- min( 1,risk.e^env*risk.g^.set1*risk.i^(.set1&env)*risk.g^.set2*risk.hap.dis[1])
   aff2<-sample(c(1,0),1,prob=c(risk.kid,1-risk.kid),replace=T)

    family.kid <- c(count.fam, 1,env, geno.kid)
    family.kid2 <- c(count.fam, aff2,env, geno.kid2)
    family.father <- c(count.fam, 0,env,  geno.f)
    family.mother <- c(count.fam, 0,env,  geno.m)
        }
     family<-rbind(family.father,family.mother,family.kid,family.kid2)
   count.fam<-count.fam+1
   write(t(family),ncol=dim(family)[2],file='cleft.ped',append=.append)
cat('total.n:',total.n,
'snp.ct.e1',snp.ct.e1,'snp.ct.e0',snp.ct.e0,'snp.ct0.e1',snp.ct0.e1,'snp.ct0.e0',snp.ct0.e0,
'set.ct.e1',set.ct.e1,'set.ct.e0',set.ct.e0,'set.ct0.e1',set.ct0.e1,'set.ct0.e0',set.ct0.e0,'env',env.ct,'\n')
        }
    }
paste('total.n:',total.n,
'snp.ct.e1',paste(snp.ct.e1,collapse=' '),'snp.ct.e0',paste(snp.ct.e0,collapse=' '),'snp.ct0.e1',paste(snp.ct0.e1,collapse=' ')
	  ,'snp.ct0.e0',paste(snp.ct0.e0,collapse=' '),'set.ct.e1',paste(set.ct.e1,collapse=' '),'set.ct.e0',paste(set.ct.e0,collapse=' '),
	  'set.ct0.e1',paste(set.ct0.e1,collapse=' '),'set.ct0.e0',paste(set.ct0.e0,collapse=' '),'env',env.ct) -> rst
	write(rst,file= 'total.n')

#############
	read.table('cleft.ped')->ped
	read.table('total.n',as.is=T)->counts
	n.case <- dim(ped)[1]/4
	total.n <- counts[1,2]
	risk.kid2 <- sum(ped[,2])/dim(ped)[1]*4 -1
	pop.risk <- dim(ped)[1]/4/total.n
	n.set <-2
	n.loci <- (dim(ped)[2]-3)/n.set
	env <- ped[seq(3,dim(ped)[1],4),3]
	mut1 <- ped[seq(3,dim(ped)[1],4),4:(3+n.loci)]
	mut2 <- ped[seq(3,dim(ped)[1],4),(4+n.loci):(3+2*n.loci)]
	
### set1
	ct.set <- as.numeric(counts[1,c(43,40,49,46)])
	set.case.e0 <- sum(apply(mut1>0,1,sum)==n.loci & (env==0))
	set.case.e1 <- sum(apply(mut1>0,1,sum)==n.loci & (env==1))
	set0.case.e0 <- sum(env==0) - set.case.e0
	set0.case.e1 <- sum(env==1) - set.case.e1
	set.ctrl.e0  <- ct.set[1] -set.case.e0
	set.ctrl.e1  <- ct.set[2] -set.case.e1
	set0.ctrl.e0 <- ct.set[3] -set0.case.e0
	set0.ctrl.e1 <- ct.set[4] -set0.case.e1
	
	set.rr.e1 <- set.case.e1/(set.case.e1+set.ctrl.e1)/set0.case.e1*(set0.case.e1+set0.ctrl.e1)
	set.rr.e0 <- set.case.e0/(set.case.e0+set.ctrl.e0)/set0.case.e0*(set0.case.e0+set0.ctrl.e0)
	
### set2
	ct.set <- as.numeric(counts[1,c(44,41,50,47)])
	set.case.e0 <- sum(apply(mut2>0,1,sum)==n.loci & (env==0))
	set.case.e1 <- sum(apply(mut2>0,1,sum)==n.loci & (env==1))
	set0.case.e0 <- sum(env==0) - set.case.e0
	set0.case.e1 <- sum(env==1) - set.case.e1
	set.ctrl.e0  <- ct.set[1] -set.case.e0
	set.ctrl.e1  <- ct.set[2] -set.case.e1
	set0.ctrl.e0 <- ct.set[3] -set0.case.e0
	set0.ctrl.e1 <- ct.set[4] -set0.case.e1
	
	set2.rr.e1 <- set.case.e1/(set.case.e1+set.ctrl.e1)/set0.case.e1*(set0.case.e1+set0.ctrl.e1)
	set2.rr.e0 <- set.case.e0/(set.case.e0+set.ctrl.e0)/set0.case.e0*(set0.case.e0+set0.ctrl.e0)
	
### set1-snp
	ct.set <- as.numeric(counts[1,c(13,4,31,22)])
	set.case.e0 <- sum(mut1[,1]>0 & (env==0))
	set.case.e1 <- sum(mut1[,1]>0 & (env==1))
	set0.case.e0 <- sum(env==0) - set.case.e0
	set0.case.e1 <- sum(env==1) - set.case.e1
	set.ctrl.e0  <- ct.set[1] -set.case.e0
	set.ctrl.e1  <- ct.set[2] -set.case.e1
	set0.ctrl.e0 <- ct.set[3] -set0.case.e0
	set0.ctrl.e1 <- ct.set[4] -set0.case.e1
	
	snp.rr.e1 <- set.case.e1/(set.case.e1+set.ctrl.e1)/set0.case.e1*(set0.case.e1+set0.ctrl.e1)
	snp.rr.e0 <- set.case.e0/(set.case.e0+set.ctrl.e0)/set0.case.e0*(set0.case.e0+set0.ctrl.e0)
	
### set2-snp
	ct.set <- as.numeric(counts[1,c(17,8,35,26)])
	set.case.e0 <- sum(mut2[,1]>0 & (env==0))
	set.case.e1 <- sum(mut2[,1]>0 & (env==1))
	set0.case.e0 <- sum(env==0) - set.case.e0
	set0.case.e1 <- sum(env==1) - set.case.e1
	set.ctrl.e0  <- ct.set[1] -set.case.e0
	set.ctrl.e1  <- ct.set[2] -set.case.e1
	set0.ctrl.e0 <- ct.set[3] -set0.case.e0
	set0.ctrl.e1 <- ct.set[4] -set0.case.e1
	
	snp2.rr.e1 <- set.case.e1/(set.case.e1+set.ctrl.e1)/set0.case.e1*(set0.case.e1+set0.ctrl.e1)
	snp2.rr.e0 <- set.case.e0/(set.case.e0+set.ctrl.e0)/set0.case.e0*(set0.case.e0+set0.ctrl.e0)
	
	cat('pop_prevalence:',pop.risk,'\n',
		'sib recurrence relative risk:',risk.kid2/pop.risk,'\n',
		'relative risk of set1 in the unexposed:',set.rr.e0,'\n',
		'relative risk of a SNP in set1 in the unexposed:',snp.rr.e0,'\n',
		'relative risk of set2 in the unexposed:',set2.rr.e0,'\n',
		'relative risk of a SNP in set2 in the unexposed:',snp2.rr.e0,'\n',
		'relative risk of set1 in the exposed:',set.rr.e1, '\n',
		'relative risk of a SNP in set1 in the exposed:',snp.rr.e1,  '\n',
		'relative risk of set2 in the exposed:',set2.rr.e1, '\n',
		'relative risk of a SNP in set2 in the exposed:',snp2.rr.e1,'\n')
}
######################
simu.risk<-function(hap.goal,hap.risk,hap.risk.e,e.fr,e.fr2,hap.fr1,hap.fr2,pop1.fr,disease.ratio)
  # hap.risk: risk of each genotype without exposure
  # hap.risk.e: risk of each genotype with exposure
  # disease.ratio: the ratio of background disease rates in the two pops
  # frequency of the risk hapltotype in the populations: hap.fr1 & hap.fr2
  {
     snp.num<-1
  hap.num<-2
 freq.hap0<- c(1/3,2/3)
  hap.type<- matrix(
      c(1,2,
      1,2),
      nrow=snp.num+1,byrow=T)
  freq.dis<-1/hap.risk.e[3]
  risk.hap.dis<-hap.risk*freq.dis
  risk.hap.dis.e<-hap.risk.e*freq.dis
  risk.hap.dis2<-hap.risk*freq.dis/disease.ratio
  risk.hap.dis.e2<-hap.risk.e*freq.dis/disease.ratio

 #change risk hap fr and rewieght the rest haps
  freq.hap1<-freq.hap0
  freq.hap2<-freq.hap0

  freq.hap1[-hap.goal] <-freq.hap0[-hap.goal]/sum(freq.hap0[-hap.goal])*(1-hap.fr1)
  freq.hap1[hap.goal]<-hap.fr1

  freq.hap2[-hap.goal] <-freq.hap0[-hap.goal]/sum(freq.hap0[-hap.goal])*(1-hap.fr2)
  freq.hap2[hap.goal]<-hap.fr2
 run.sim(snp.num,(hap.num), hap.goal,freq.hap1,hap.type,risk.hap.dis,risk.hap.dis.e,e.fr,
          freq.hap2, risk.hap.dis2,risk.hap.dis.e2, e.fr2,pop1.fr,n.fam)
 }
############################################################################
n.fam<-10  # Number of families * THIS IS A PARAMTER TO BE CHANGED BY USER* 
M<- 1500      # Relative risk of high-risk sufficient multi-locus genotype in the exposed group  * THIS IS A PARAMTER TO BE CHANGED BY USER* 
fr <- 0.0566 # Frequency of high-risk sufficient multi-locus genotype * THIS IS A PARAMTER TO BE CHANGED BY USER* 
r.e <-1.5      #  Relative risk of the exposure (smoking) * THIS IS A PARAMTER TO BE CHANGED BY USER* 
i1<-2          #  Relative risk of gene-by-environment interaction for 1 copy of the multi-locus genotype  * THIS IS A PARAMTER TO BE CHANGED BY USER* 
i2<-2          #  Relative risk of gene-by-environment interaction for 2 copies of the multi-locus genotype * THIS IS A PARAMTER TO BE CHANGED BY USER* 

r1<-M/r.e/i1     # Relative risk of carrying 1 copy of the multi-locus genotype 
r2<-M/r.e/i2     # Relative risk of carrying 2 copies of the multi-locus genotype
simu.risk(hap.goal=2,hap.risk=c(1,r1,r2),hap.risk.e=c(r.e,r.e*r1*i1,r.e*r2*i2),e.fr=0.3,e.fr2=0.3,hap.fr1=fr,hap.fr2=fr,pop1.fr=0.5,
          disease.ratio=1)


